<template>
  <ObModal
          ref="ob-modal"
          :title="editTitle"
          size="large"
          :is-center="false"
          @save="update"
  >
    <ObForm
            v-show="Object.keys(formData).length"
            class="form-content"
            :ref="formRefName"
            :form-data="formData"
            :form-model="formModel"
            :dropdown-menu="dropdownMenu"
            @submit="update"
            @cancel="parentModalClose"
            :is-submit-disabled="false"
    >
      <ObTabs ref="tabs">
        <ObTabsPane title="Общие настройки">
          <div class="row">
            <div class="col-xs-12">
              <ObSelect
                      v-model="commonSettings.participant_role_codes"
                      label="Роли участников, для которых применяется этот параметр"
                      placeholder="Выберите минимум одну роль"
                      :remote-opt="loadRoles"
                      :is-multiselect="true"
                      :is-dropdown="true"
                      display-exp="title"
                      value-exp="code"
                      property="participant_role_codes"
              />
            </div>
          </div>
          <div class="row">
            <div class="col-xs-12">
              <ObSelect
                      v-model="commonSettings.activities"
                      label="Направление деятельности Поставщика"
                      placeholder="Активно, если указана роль Поставщик"
                      :disabled="!isCarrier"
                      :remote-opt="getActivities"
                      :remote-trigger="isCarrier"
                      :is-multiselect="true"
                      :is-dropdown="true"
                      display-exp="denomination"
                      property="activities"
                      @on-load-list="setActivitiesList"
              />
            </div>
          </div>
          <div class="row">
            <div class="col-xs-12">
              <ob-checkbox
                      :label="'Оценка риска'"
                      v-model="commonSettings.need_risk_assessment"
                      :disabled="!adminSource.need_risk_assessment"
              />
            </div>
          </div>
        </ObTabsPane>
        <ObTabsPane title="Источники данных">
          <div class="form-content">
            <div class="row">
              <div class="col-xs-12">
                <ob-checkbox
                        :label="'Ручной ввод участником'"
                        v-model="sourceSettings.need_manual_filling"
                />
              </div>
            </div>
            <div class="row">
              <div class="col-xs-12">
                <ob-checkbox
                        :label="'Распознавание документов'"
                        v-model="sourceSettings.need_recognition"
                        :disabled="!adminSource.need_recognition"
                />
              </div>
            </div>
            <transition name="slide-down" mode="out-in">
              <div class="row" v-show="sourceSettings.need_recognition">
                <div class="col-xs-12">
                  <ObSelect
                          :items="adminSource.reg_docs_for_recognition || []"
                          :label="'Документы, которые необходимо получить от участника для заполнения поля СБшником'"
                          :placeholder="''"
                          :is-multiselect="true"
                          :is-standart="true"
                          v-model="sourceSettings.reg_docs_for_recognition_uuids"
                  />
                </div>
              </div>
            </transition>
            <transition name="slide-down" mode="out-in">
              <div class="row" v-show="sourceSettings.need_recognition">
                <div class="col-xs-12">
                  <ObSelect
                          :items="adminSource.recognition_services || []"
                          :label="'Сервисы для распознавания документов'"
                          :placeholder="''"
                          :is-multiselect="true"
                          :is-standart="true"
                          v-model="sourceSettings.recognition_services_uuids"
                  />
                </div>
              </div>
            </transition>
            <div class="row">
              <div class="col-xs-12">
                <ob-checkbox
                        :label="'Ручной ввод владельцем домена'"
                        v-model="sourceSettings.need_verification"
                />
              </div>
            </div>
            <transition name="slide-down" mode="out-in">
              <div class="row" v-show="sourceSettings.need_verification">
                <div class="col-xs-12">
                  <ObSelect
                          :items="adminSource.reg_docs_for_verification || []"
                          :label="'Документы'"
                          :placeholder="'Выберите документы'"
                          :isMultiselect="true"
                          v-model="sourceSettings.reg_docs_for_verification_uuids"
                  />
                </div>
              </div>
            </transition>
            <div class="row">
              <div class="col-xs-12">
                <ob-checkbox
                        :label="'Внешние источники'"
                        v-model="sourceSettings.need_filling_by_external"
                        :disabled="!adminSource.need_filling_by_external"
                />
              </div>
            </div>
            <transition name="slide-down" mode="out-in">
              <div class="row" v-show="sourceSettings.need_filling_by_external">
                <div class="col-xs-12">
                  <ObSelect
                          :items="adminSource.external_services || []"
                          :label="'Сервисы для получение данных'"
                          :placeholder="''"
                          :isMultiselect="true"
                          v-model="sourceSettings.external_services_uuids"
                  />
                </div>
              </div>
            </transition>
            <div class="row">
              <div class="col-xs-12">
                <ob-switcher-checkbox
                        :label="'Cовпадение значений обязательно'"
                        v-model="sourceSettings.need_value_match"
                />
              </div>
            </div>
          </div>
        </ObTabsPane>
        <ObTabsPane title="Оценка риска" :is-hidden="!commonSettings.need_risk_assessment">
          <FieldRisks :data-source="dataSource" :form-data="commonSettings" :activities="activitiesList" ref="risks" @on-set-default-risks="setDefaultRisks"/>
        </ObTabsPane>
      </ObTabs>
    </ObForm>
  </ObModal>
</template>

<script>
  import models from '../../../models'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObTabs from 'common-components/src/obComponents/obTabs'
  import ObTabsPane from 'common-components/src/obComponents/obTabs/ObTabsPane'
  import FieldRisks from './FieldRisks'
  import ObCheckbox from "common-components/src/obComponents/obCheckbox"
  import ObSwitcherCheckbox from "common-components/src/obComponents/obSwitcherCheckbox"
  import ObModal from "common-components/src/obComponents/obModal"
  import api from '@/api'

  export default {
    name: "modalFieldEdit",
    mixins: [
      FormValidationMixin
    ],
    components: {
      ObForm,
      ObSelect,
      ObCheckbox,
      ObSwitcherCheckbox,
      ObTabs,
      ObTabsPane,
      FieldRisks,
      ObModal
    },
    props: {
      dataSource: {
        type: Object,
        default: () => {
        }
      },
      disabledForm: Boolean
    },
    filters: {
      riskColor: (value, riskGroups) => {
        if (!value) return '';
        let group = riskGroups.find(i => i.uuid === value);
        return group ? 'select-risk-group select-risk-group_' + group.color : '';
      }
    },
    data() {
      return {
        sourceSettings: {
          need_manual_filling: false,
          need_recognition: false,
          reg_docs_for_recognition_uuids: [],
          recognition_services_uuids: [],
          need_verification: false,
          reg_docs_for_verification_uuids: [],
          need_filling_by_external: false,
          external_services_uuids: [],
          has_multiple_value: true
        },
        commonSettings: {
          activities: [],
          datatype: null,
          need_risk_assessment: false,
          participant_role_codes: [],
          title: null
        },
        activitiesList: []
      }
    },
    computed: {
      formModel() {
        return models.cardFields.edit
      },
      dropdownMenu() {
        return [
          {
            title: "Перевести в статус «Неактивно»",
            className: 'color-error',
            method: () => this.deactivateField()
          },
          {
            title: "Взять значения по умолчанию",
            method: () => this.setDefaultRisks()
          }
        ]
      },
      isCarrier() {
        return this.commonSettings.participant_role_codes && this.commonSettings.participant_role_codes.includes('CARRIER')
      },
      mainInfo() {
        return this.formData && this.formData && this.formData.ParticipantCommonDomainReadSettings || {}
      },
      adminSource() {
        return this.formData && this.formData && this.formData.AdminDataSourceSettings || {}
      },
      domainSource() {
        return this.formData && this.formData && this.formData.DataSourceDomainReadSettings || {}
      },
      editTitle() {
        return this.mainInfo.title;
      },
      customMenu() {
        return [
          {
            title: 'Удалить',
            className: 'color-error',
            method: this.removeEvent
          }
        ]
      }
    },
    methods: {
      open({data = null} = {}) {
        if (data) {
          this.initData({data})
        }

        this.$refs['ob-modal'].open()

        this.$nextTick(() => {
          this.$refs['tabs'].selected = { title: 'Общие настройки' }
        })
      },
      close () {
        this.$refs['ob-modal'].close()
      },
      deactivateField() {
        alert('deactivateField')
      },
      async setDefaultRisks () {
        let notificationId = new Date().getTime()+'save';
        try {
          this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});

          let risks = this.$refs['risks']

          if (risks && risks.selectedRole) {
            let codeArr = risks.selectedRole.split('_')
            let role_code = codeArr[0]
            let activity_uuid = codeArr[1]

            await api.card.setAdminRisks({uuid: this.dataSource.uuid, role_code, activity_uuid})
            this.dataSource.riskValues = await api.card.getRiskParticipant(this.dataSource.uuid)
          }
          this.$notification({
            type: 'system_notification_success',
            message: 'Сохранено'
          })
        } catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Не сохранено'
          })
        } finally {
          this.$notification({event: 'close', id: notificationId})
        }
      },
      async loadDocumentsList() {
        try {
          return await api.cardField.getDocs({type: 'participant'})
        } catch (e) {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        }
      },
      async loadServices() {
        try {
          let res = await api.cardField.getServices()
          return {content: res}
        } catch (e) {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        }
      },
      async loadRoles() {
        try {
          return await api.cardField.getRolesParticipant({uuid: this.dataSource.uuid})
        } catch (e) {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        }
      },
      async getActivities() {
        try {
          return await api.card.activitiesDropdown()
        } catch (e) {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        }
      },
      initData({data}) {
        let {DataSourceDomainReadSettings, ParticipantCommonDomainReadSettings} = data

        this.sourceSettings.need_manual_filling = DataSourceDomainReadSettings.need_manual_filling
        this.sourceSettings.reg_docs_for_recognition_uuids = DataSourceDomainReadSettings.reg_docs_for_recognition.map(item => item.uuid)
        this.sourceSettings.recognition_services_uuids = DataSourceDomainReadSettings.recognition_services.map(item => item.uuid)
        this.sourceSettings.need_verification = DataSourceDomainReadSettings.need_verification
        this.sourceSettings.reg_docs_for_verification_uuids = DataSourceDomainReadSettings.reg_docs_for_verification.map(item => item.uuid)
        this.sourceSettings.need_filling_by_external = DataSourceDomainReadSettings.need_filling_by_external
        this.sourceSettings.external_services_uuids = DataSourceDomainReadSettings.external_services.map(item => item.uuid)
        this.sourceSettings.has_multiple_value = DataSourceDomainReadSettings.has_multiple_value
        this.sourceSettings.need_recognition = DataSourceDomainReadSettings.need_recognition

        this.commonSettings.participant_role_codes = ParticipantCommonDomainReadSettings.participant_role_codes
        this.commonSettings.activities = ParticipantCommonDomainReadSettings.activities.map(item => item.uuid)
        this.commonSettings.need_risk_assessment = ParticipantCommonDomainReadSettings.need_risk_assessment
        this.commonSettings.datatype = ParticipantCommonDomainReadSettings.datatype
        this.commonSettings.title = ParticipantCommonDomainReadSettings.title
        this.commonSettings.uuid = data.uuid
      },
      async update() {
        let notificationId = new Date().getTime()+'save';
        try {
          this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});

          let formData = {
            ParticipantCommonDomainCreationSettings: {
              participant_role_codes: this.commonSettings.participant_role_codes,
              activities: this.commonSettings.activities,
              need_risk_assessment: this.commonSettings.need_risk_assessment,
            },
            DataSourceDomainCreationSettings: {
              DataSourceSettings: {
                ...this.sourceSettings
              }
            }
          }

          await api.card.updateParticipantDetail({uuid: this.dataSource.uuid, data: formData})

          if (this.commonSettings.need_risk_assessment) {
            let currentRisks = this.$refs.risks.risks
            let resultRisks = []

            for (let key in currentRisks) {
              let array = currentRisks[key]
              let codeArr = key.split('_')
              let role_code = codeArr[0]
              let activity_uuid = codeArr[1]

              if (array && array.length) {
                array.forEach(group => {
                  resultRisks.push({
                    role_code,
                    activity_uuid,
                    loss_group_uuid: group.uuid || group.loss_group_uuid,
                    constraints: group.constraints,
                    is_active: true
                  })
                })
              }
            }

            await api.card.setRiskParticipant({uuid: this.dataSource.uuid, risks: resultRisks})
          }

          this.close()
          this.$notification({
            type: 'system_notification_success',
            message: 'Сохранено'
          })
        } catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Не сохранено'
          })
        } finally {
          this.$notification({event: 'close', id: notificationId})
        }
      },
      async removeEvent() {
        let notificationId = new Date().getTime()+'remove';
        try {
          this.$notification({type: 'system_notification_in_load', message: 'Удаление', id: notificationId});
          await api.card.remove(this.formData.uuid)
          this.$refs.modal.close()

          this.$notification({
            type: 'system_notification_success',
            message: 'Удалено'
          })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Не удалено'
          })
        } finally {
          this.$notification({event: 'close', id: notificationId})
        }
    }
    ,
      setActivitiesList(data) {
        this.activitiesList = data
      }
    }
  };
</script>

<style lang="scss" scoped>
  .form-content {
    .form-item-container {
      width: 100%;
    }
  }

  .form-group {
    width: 100%;
    display: flex;
    justify-content: space-between;
    align-self: flex-start;
    & > div {
      & + div:not(.checkbox-wrapper) {
        margin-left: 20px;
      }
    }

    .checkbox-wrapper {
      margin-right: 30px;
      margin-bottom: 10px;
    }

    .title {
      margin-bottom: 20px;
      font-style: normal;
      font-weight: normal;
      font-size: 16px;
      line-height: 18px;
      letter-spacing: 0.2px;
      color: $organizationsCardConfiguratorPage-form_group_title;
    }

    .date-wrap {
      margin: 0;
    }
  }
</style>
